/*
 *    The term 'program' used in the copyright and the license below means
 *    PReP Version 1.0 
 *
 *    Copyright (C) 1998, 1999 DELECis
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    This copyright notice must appear in all copies and modifications.
 *
 *    Contact: prep@delec.com
 *
 *    Read the manual: http://www.delec.com/is/products/prep/manual/jprep/
 */

/**
 * PReP Version 1.0
 *
 * PRePException: consists of the class which caused the exception, the exception itself and
 *                a number (errorlevel)
 *
 *                the default errorlevel is 1
 *
 *                a list of PRePExceptions is stored in session
 *
 * History: - Creation 12/21/98 nh
 *
 * Date: 12/21/98
 * @author nh
 * @version 1.0
 */

package com.delec.prep;

public class PRePException
{
  Object objClass;
  Object objException;
  int iErrorlevel;

  public PRePException(Object objClass, Object objException)
  {
    this(objClass, objException, 1);
  }

  public PRePException(Object objClass, Object objException, int iErrorlevel)
  {
    this.objClass = objClass;
    this.objException = objException;
    this.iErrorlevel = iErrorlevel;
  }

  public String outException()
  {
      if (objClass != null) 
	  {      
	  return "The "+objClass.getClass()+" caused a "+objException+" with the errorlevel "+iErrorlevel+"<BR>";
      }
      else
      {
	  return "unknown class caused a "+objException+" with the errorlevel "+iErrorlevel+"<BR>";
      }
  }

  public Object getCausingClass()
  {
      if (objClass != null) {      
	  return objClass.getClass();
      }
      else 
      {
	  return null;
      }
  }
  
  public Object getException()
  {
    return objException;
  }

  public int getErrorlevel()
  {
    return iErrorlevel;
  }
}
