/*
 *    The term 'program' used in the copyright and the license below means
 *    PReP Version 1.0 
 *
 *    Copyright (C) 1998, 1999 DELECis
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    This copyright notice must appear in all copies and modifications.
 *
 *    Contact: prep@delec.com
 *
 *    Read the manual: http://www.delec.com/is/products/prep/manual/jprep/
 */

/**
 * PReP Version 1.0
 *
 * PRePPreparse: Takes all the comments in the prep file away (@@)
 *
 * History: - Creation nh
 *
 * @author nh
 * @version 1.0
 */
 
package com.delec.prep;

import java.io.*;

public class PRePPreparse 
{
  final String strComment = "@@";

  /**
   * preparse will skip all comments (begin with @@) 
   * @param BufferedReader (file)
   * @return the file without the comments
   */

  public String preparse(BufferedReader bReader) {  
    String strInput = "";
    try {
      strInput = bReader.readLine();
      int index = 0;
      if (strInput != null) {
	if ((index = strInput.indexOf(strComment))!= -1) {
	  if(index == 0)
	    {
	      strInput = preparse(bReader);
	    }
	  else
	    {
	      strInput = strInput.substring(0, index);
	    }
	}
      /*  if (strInput.trim().equals("\n")
	    || strInput.trim().equals("\r")
	    || strInput.trim().equals("\n\r")
	    || strInput.trim().equals("\r\n")) 
	    {
	    strInput = preparse(bReader);
	}*/
      }
    }
    catch (Exception e) {     
	System.out.println("exception in preparse: "+e);
    }
    return strInput;
  }
}
